# WARNING: Do not edit by hand, this file was generated by Crank:
#
#   https://github.com/gocardless/crank
#

from . import base_service
from .. import resources
from ..paginator import Paginator
from .. import errors

class LogosService(base_service.BaseService):
    """Service class that provides access to the logos
    endpoints of the GoCardless Pro API.
    """

    RESOURCE_CLASS = resources.Logo
    RESOURCE_NAME = 'logos'


    def create_for_creditor(self,params=None, headers=None):
        """Create a logo associated with a creditor.

        Creates a new logo associated with a creditor. If a creditor already
        has a logo, this will update the existing logo linked to the creditor.
        
        We support JPG and PNG formats. Your logo will be scaled to a maximum
        of 300px by 40px. For more guidance on how to upload logos that will
        look
        great across your customer payment page and notification emails see
        [here](https://developer.gocardless.com/gc-embed/setting-up-branding#tips_for_uploading_your_logo).

        Args:
              params (dict, optional): Request body.

        Returns:
              Logo
        """
        path = '/branding/logos'
        
        if params is not None:
            params = {self._envelope_key(): params}

        response = self._perform_request('POST', path, params, headers,
                                         retry_failures=True)
        return self._resource_for(response)
  
