# WARNING: Do not edit by hand, this file was generated by Crank:
#
#   https://github.com/gocardless/crank
#

from . import base_service
from .. import resources
from ..paginator import Paginator
from .. import errors

class NegativeBalanceLimitsService(base_service.BaseService):
    """Service class that provides access to the negative_balance_limits
    endpoints of the GoCardless Pro API.
    """

    RESOURCE_CLASS = resources.NegativeBalanceLimit
    RESOURCE_NAME = 'negative_balance_limits'


    def list(self,params=None, headers=None):
        """List negative balance limits.

        Returns a [cursor-paginated](#api-usage-cursor-pagination) list of
        negative balance limits.

        Args:
              params (dict, optional): Query string parameters.

        Returns:
              ListResponse of NegativeBalanceLimit instances
        """
        path = '/negative_balance_limits'
        

        response = self._perform_request('GET', path, params, headers,
                                         retry_failures=True)
        return self._resource_for(response)

    def all(self, params=None):
        if params is None:
            params = {}
        return Paginator(self, params)
    
  

    def create(self,params=None, headers=None):
        """Create a negative balance limit.

        Creates a new negative balance limit, which replaces the existing limit
        (if present) for that currency and creditor combination.
        

        Args:
              params (dict, optional): Request body.

        Returns:
              NegativeBalanceLimit
        """
        path = '/negative_balance_limits'
        
        if params is not None:
            params = {self._envelope_key(): params}

        response = self._perform_request('POST', path, params, headers,
                                         retry_failures=True)
        return self._resource_for(response)
  
